<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
<!-- bootstrap -->
<link href="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<! -- fontawesome (document est static donc ref /static) -->
{{ fontawesome_html() }}

  <title>Documentation Jupyter Nbgrader</title>
  <style type="text/css">
      code{white-space: pre-wrap; background-color:lightyellow; padding: .2em .4em;display:block;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
      nav#TOC{float: right; margin: 1em; border: 1px solid gray; background-color: #f0f998; }
      h1.title{text-align:center; background-color: lightblue; }
  </style>
</head>
<body>
<p style="color:blue">
<div style="float:left;">
	<img src="{{ url_for('static', filename='images/LogoUCB.png') }}" alt="Lyon 1" width="100">
&emsp;
<a href="https://fst-meca.univ-lyon1.fr">Département Mécanique
&emsp;
<i class="fas fa-university"></i>
</a></div>
<div style="float:right;">
<a href="{{ url_for('get_home') }}">
Home &emsp;
<i class="fas fa-sign-in-alt"></i>
&emsp;
</a></div>
<div style="clear: both;"></div>
</p>
<header id="title-block-header">
<h1 class="title">Documentation Jupyter Nbgrader</h1>
</header>
<nav id="TOC">
<ul>
<li><a href="#serveur-nbgrader">Serveur Nbgrader</a>
<ul>
<li><a href="#documentation-officiel">documentation officiel:</a></li>
</ul></li>
<li><a href="#utilisation-coté-étudiant">utilisation coté étudiant</a></li>
<li><a href="#utilisation-coté-enseignant">utilisation coté enseignant</a>
<ul>
<li><a href="#structure-dun-cours">structure d’un cours</a></li>
<li><a href="#répertoire-des-notebooks">répertoire des notebooks</a></li>
<li><a href="#gestion-des-notebooks">gestion des notebooks</a>
<ul>
<li><a href="#manage-assignements">Manage Assignements</a></li>
<li><a href="#manage-students">Manage Students</a></li>
<li><a href="#manual-grading">Manual grading</a></li>
</ul></li>
</ul></li>
</ul>
</nav>
<h1 id="serveur-nbgrader">Serveur Nbgrader</h1>
<p>nbgrader est un outil qui facilite la création et la notation de devoirs utilisants des notebooks Jupyter, ainsi que la distribution ainsi que la récupération de ces devoirs aux étudiants. Il permet aux enseignants de créer facilement des devoirs basés sur des botebooks qui incluent à la fois des exercices de programmation, du texte explicatif, des images ou des vidéos, et des réponses libres écrites. nbgrader fournit également une interface simplifiée pour gérer les devoirs.</p>
<h2 id="documentation-officiel">documentation officiel:</h2>
<ul>
<li><a href="https://nbgrader.readthedocs.io/en/stable/">https://nbgrader.readthedocs.io/en/stable/</a></li>
</ul>
<h1 id="utilisation-coté-étudiant">utilisation coté étudiant</h1>
<p>Quand vous vous connectez sur un serveur nbgrader, vous avez par défaut un rôle étudiant, et vous avez accès aux versions étudiants des notebooks.</p>
<p>Pour cela allez dans le menu <strong>Assignements</strong>, puis choisir le cours dans la boite de dialogue <em>Released, downloaded, and submitted assignments for course:</em></p>
<p>Voua avez alors un affichage de 3 cases:</p>
<ol type="1">
<li><p><strong>Released assignments</strong> qui affiche la liste des notebooks du cours que vous pouvez télécharger (en cliquant sur <strong>fetch</strong>)</p></li>
<li><p><strong>Downloaded assignments</strong> qui affiche la liste des notebooks du cours que vous avez téléchargé. vous pouvez ensuite soumettre votre notebook pour évaluation en cliquant sur <strong>submit</strong></p></li>
<li><p><strong>Submitted assignments</strong> qui affiche la liste des notebooks du cours que vous avez soumis avec la date de soumission.</p></li>
</ol>
<p><strong>REMARQUES</strong> - un notebook téléchargé ne peut plus être téléchargé à nouveau (il faut dans ce cas supprimer le répertoire du notebook sur votre compte sur le serveur qui se trouve dans le dossier: NOM_COURS-&gt;NOM_TP)</p>
<ul>
<li><p>la commande <strong>validate</strong> permet de passer tout les tests sur le notebook et renvoie une erreur en cas d’erreur (en général à ne pas le faire utiliser par les étudiants)</p></li>
<li><p>un même notebook peut être soumis plusieurs fois: seul la dernière version est prise en compte (à utiliser avec modération car cela occupe de l’espace disque inutilement)</p></li>
</ul>
<h1 id="utilisation-coté-enseignant">utilisation coté enseignant</h1>
<p>pour avoir accès au cours coté enseignant, il faut avoir été inscrit dans l’équipe pédagogique du cours. Dans ce cas, il faut cliquez sur le bouton en haut à gauche <strong>Control Panel</strong>, puis sur <strong>Services</strong> et choisir dans la liste le nom du cours (code APOGEE).</p>
<p>On a alors accès au répertoire du cours et à tous les fichiers du cours et à la gestion des notebooks pour les étudiants.</p>
<h2 id="structure-dun-cours">structure d’un cours</h2>
<p>Un cours sous Jupyter nbgrader est associé à un répertoire sur le serveur. Le nom du cours est par convention son code APOGEE. Par exemple le répertoire du cours <strong>MGC2005L</strong> a la structure suivante</p>
<ul>
<li>répertoire du cours <strong>MGC2005L</strong></li>
</ul>
<p>
<span style="display:block;background:lightyellow;"> <b>MGC2005L/</b><br> ├── <i>autograded</i><br> │ ├── p1801574<br> │ │ └── TP4_Meule<br> │ ├── p1811042<br> │ │ └── TP4_Meule<br> │ └── p2006068<br> │     └── TP4_Meule<br> ├── <i>release</i><br> │ ├── TP4_Meule<br> │ └── TP5_Bille<br> ├── <b>source</b><br> │ ├── TP4_Meule<br> │ └── TP5_Bille<br> ├── <i>submitted</i><br> │ ├── p1801574<br> │ │ └── TP4_Meule<br> │ ├── p1811042<br> │ │ ├── TP3_Toupie3D<br> │ │ ├── TP4_Meule<br> │ │ └── TP5_Bille<br> │ └── p2006068<br> │     ├── TP4_Meule<br> │     └── TP5_Bille<br> └── <b>validation</b><br> </span>
</p>
<p>Les répertoires en italique sont crées automatiquement par <strong>nbgrader</strong></p>
<dl>
<dt><em>release</em></dt>
<dd>contient les TP mis en ligne par l’enseignant responsable du cours ( menu Formgrader de l’interface jupyter nbgrader)
</dd>
<dt><em>submitted</em></dt>
<dd>contient les TP qui ont été soumis par les étudiants. Pour chaque étudiant on trouve les TP soumis par cet étudiant
</dd>
<dt><em>nbgrader</em></dt>
<dd>contient le résultat de l’évaluation des TP par le système nbgrader, avec la même structure par étudiant
</dd>
</dl>
<p>Les répertoires en gras sont générés par l’administrateur</p>
<ul>
<li><p><strong>source</strong> contient les TP que l’enseignant fournit aux étudiants (dans l’exemple TP4_Meule et TP5_Bille)</p></li>
<li><p><strong>validation</strong> contient les résultats de l’analyse avec les outils de validation pour chacun des TP</p></li>
</ul>
<h2 id="répertoire-des-notebooks">répertoire des notebooks</h2>
<p>les notebooks de cours, devoirs ou de TP sont placés dans des sous-répertoires du répertoire source. Chaque sous-répertoire, p.e. TP4_Meule, représente un TP ou devoir, et peut contenir un ou plusieurs fichiers de notebooks (extension .ipynb), des fichiers images ou vidéo, des bibliothèques python, des fichiers de données ou des documents au format pdf.</p>
<p>Lorsqu’un étudiant récupère un TP ou devoir (<strong>fetch</strong>), il récupère la totalité du répertoire avec tous les fichiers.</p>
<p>De même, lorsqu’un étudiant soumet son travail (<strong>submit</strong>), il transmet la totalité des fichiers du répertoire.</p>
<h2 id="gestion-des-notebooks">gestion des notebooks</h2>
<p>On utilise le menu <strong>Formgrader</strong></p>
<h3 id="manage-assignements">Manage Assignements</h3>
<p>Dans l’option <strong>Manage Assignements</strong>, on gère la mise a disposition et la récupération des devoirs. Les différentes étapes sont:</p>
<ol type="1">
<li><strong>Generate</strong> génération de la version étudiant du notebook</li>
<li><strong>Preview</strong> possibilité de visualisé cette version avant de la mettre en ligne</li>
<li><strong>Release</strong> mise à disposition des notebooks aux les étudiants</li>
<li><strong>Collect</strong> récupération des notebooks soumis par les étudiants</li>
<li><strong>Submission</strong> nbre de notebooks récupérés</li>
</ol>
<h3 id="manage-students">Manage Students</h3>
<p>gestion des étudiants (avec les notes) avec une notation automatique (<strong>autograde</strong>).</p>
<h3 id="manual-grading">Manual grading</h3>
<p>notation manuelle des étudiants</p>
<p><strong>remarque</strong> la gestion et la notation des notebooks peut se faire de façon plus efficace et plus simple avec le système de <strong>validation</strong> de cours mise en place sur les serveurs, qui permet aussi la gestion des étudiants et le transfert des notes vers tomuss.</p>
</body>
</html>
